#define OS_MAIN
#include <jacos.h>
#include "\jacos\prim\prim_io.h"

OST_TASK  task1;
OST_TASK  task2;
OST_TASK  task3;

OST_FLAGS event1;

unsigned char counter = 0;

__task void T_1(void)
{
  while (1) {
    counter++;
    OS_Set_Flag(&event1, 0x01);
    OS_Cooperate();
    counter++;
  }
}

__task void T_2(void)
{
  while (1) {
    counter++;
    if (counter > 17) {
      OS_Set_Flag(&event1, 0x02);
      OS_Task_Stop();
    }
    counter++;
  }
}

__task void T_3(void)
{
  while (1) {
    counter++;
    OS_Wait_Flag(&event1, 0x03);
    OS_Clear_Flag(&event1, 0x03);
    OS_Task_Resume(&task2);
    counter = 0;
  }
}

void main(void)
{
  OS_Init();
  OS_Task_Create(T_1, &task1, 0);
  OS_Task_Create(T_2, &task2, 1);
  OS_Task_Create(T_3, &task3, 2);

  OS_Flag_Create(&event1, 0);

  while (1) {
    OS_Scheduler();
  }
}


