#if defined(_PIC_)                  // PIC12, PIC16, PIC18 Hi-Tech
  #ifdef OS_USE_EV_EVRW
    #pragma interrupt_level 0
  #endif
  interrupt void intr(void)

#elif defined(_AVR_)                // AVR IAR
  #ifdef TIMER0_OVF_vect
    #pragma vector=TIMER0_OVF_vect
  #else
    #pragma vector=TIMER0_OVF0_vect
  #endif
  __interrupt void intr(void)

#elif defined(_GAVR_)               // AVR GCC WINAVR
  SIGNAL(SIG_OVERFLOW0)
  //INTERRUPT(SIG_OVERFLOW0)

#elif defined(_MSP)                 // MSP430 IAR
  #pragma vector=TIMERA1_VECTOR     // io430x11x.h
  __interrupt void intr(void)

#elif defined(_ARM_)                // ARM IAR
  __arm __irq  void intr(void)

#elif defined(_51_)                 // 8x51 Keil
  void intr(void) interrupt 1 using 2

#elif defined(_PIC18I)              // PIC18 IAR
  #pragma vector = 0x08
  __interrupt void intr(void)
#endif

