// (OS_TMR_TICK = 156)

#if defined(_PIC18) || defined(_PIC18I)   // PIC18 IAR
  PR2     = OS_TMR_TICK;                  // timer tick = 10000 instruction cycles
  INTCON  = 0xC0;
  TMR2IE  = 1;
  TMR2IF  = 0;
  T2CON   = 0x1E;
  #if defined(_PIC18)
  __CONFIG(2,WDTDIS);
  #else
  __set_configuration_bits(CONFIG3H, WDT_OFF_3);
  #endif

#elif  defined(_PIC14)                    // PIC16 Hi-Tech (14-bit)
  OPTION  = 0b00000101;                   // timer tick = 10000 instruction cycles
  INTCON  = 0b11100000;
  __CONFIG(0x3ffb);

#elif  defined(_AVR_) || defined(_GAVR_)  // AVR IAR, AVR GCC
  TCCR0   =  0x03;                        // timer tick = 10000 instruction cycles
  TIMSK   |= 0x02;                        // at90s8515
  TCNT0   = 0xFF - OS_TMR_TICK;
  OS_Ena_Int();

#endif
